-- =============================================
-- Author:		IS)Cytta
-- Create date: 08.10.2014
-- Description:	update Lock Flag & By 
--				on TB_R_MONTHLY_FORECAST
-- =============================================

CREATE PROCEDURE [dbo].[SP_AutoLockFeedback]
AS
BEGIN

SET NOCOUNT ON;

DECLARE @PROD_MONTH AS VARCHAR(MAX),
	    @TYPE AS VARCHAR(MAX),
	    @DUE_DATE AS DATE,
	    @NOW AS DATE = CAST(GETDATE() AS DATE), 
		@GAP AS INT = 0;

SET @PROD_MONTH = (SELECT MAX(PRODUCTION_MONTH) FROM TB_R_LPOP_CONFIRMATION)

SELECT 
	@TYPE = LPOP_TIMING,
	@DUE_DATE = LAST_REMINDING_DATE
FROM TB_R_LPOP_CONFIRMATION
WHERE PRODUCTION_MONTH = @PROD_MONTH
	AND APPROVE_DT = (SELECT MAX(APPROVE_DT) FROM TB_R_LPOP_CONFIRMATION WHERE PRODUCTION_MONTH = @PROD_MONTH)

/*IF(@TYPE = 'T')
BEGIN
	SET @GAP = 3;
END
ELSE IF (@TYPE = 'F')
BEGIN
	SET @GAP = 5;
END*/

--SET @DUE_DATE = DATEADD(DAY, 1, @DUE_DATE);

IF(@NOW > @DUE_DATE)
BEGIN
	IF(@TYPE = 'F')
	BEGIN
		UPDATE TB_R_MONTHLY_FORECAST
		SET F_LOCK_STATUS = '1',
			F_LOCK_CHANGED_BY = 'System',
			F_LOCK_CHANGED_DT = GETDATE(),
			F_FEEDBACK_DT=GETDATE(),
			F_FEEDBACK_USER='System'
		WHERE PRODUCTION_MONTH = @PROD_MONTH
	END
	ELSE
	BEGIN
		UPDATE TB_R_MONTHLY_FORECAST
		SET T_LOCK_STATUS = '1',
			T_LOCK_CHANGED_BY = 'System',
			T_LOCK_CHANGED_DT = GETDATE(),
			T_FEEDBACK_DT=GETDATE(),
			T_FEEDBACK_USER='System'
		WHERE PRODUCTION_MONTH = @PROD_MONTH
	END
END

END

